Package org.apache.ignite.internal.binary

## Interface BinaryMetadataHandler

All Known Implementing Classes:
  `BinaryCachingMetadataHandler`, `BinaryNoopMetadataHandler`

    public interface BinaryMetadataHandler

Binary metadata handler.

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `addMeta​(int typeId, BinaryType meta, boolean failIfUnregistered)` Adds a new or updates an existing metadata to the latest version.
`void` `addMetaLocally​(int typeId, BinaryType meta, boolean failIfUnregistered)` Adds meta data locally on current node without sending any messages.
`Collection<BinaryType>` `metadata()` Gets all metadata known to the node.
`BinaryType` `metadata​(int typeId)` Gets metadata for provided type ID.
`BinaryType` `metadata​(int typeId, int schemaId)` Gets metadata for provided type ID and schema ID.
`BinaryMetadata` `metadata0​(int typeId)` Gets unwrapped metadata for provided type ID.

### Method Detail

#### addMeta

    void addMeta​(int typeId,
                 BinaryType meta,
                 boolean failIfUnregistered)
          throws BinaryObjectException

Adds a new or updates an existing metadata to the latest version. See `MetadataUpdateProposedMessage` javadoc for detailed protocol description.

Parameters:
  `typeId` - Type ID.
  `meta` - Metadata.
  `failIfUnregistered` - Fail if unregistered.
Throws:
  `BinaryObjectException` - In case of error.

#### addMetaLocally

    void addMetaLocally​(int typeId,
                        BinaryType meta,
                        boolean failIfUnregistered)
                 throws BinaryObjectException

Adds meta data locally on current node without sending any messages.

Parameters:
  `typeId` - Type ID.
  `meta` - Metadata.
  `failIfUnregistered` - Fail if unregistered.
Throws:
  `BinaryObjectException` - In case of error.

#### metadata

    BinaryType metadata​(int typeId)
                 throws BinaryObjectException

Gets metadata for provided type ID.

Parameters:
  `typeId` - Type ID.
Returns:
  Metadata.
Throws:
  `BinaryObjectException` - In case of error.

#### metadata0

    BinaryMetadata metadata0​(int typeId)
                      throws BinaryObjectException

Gets unwrapped metadata for provided type ID.

Parameters:
  `typeId` - Type ID.
Returns:
  Metadata.
Throws:
  `BinaryObjectException` - In case of error.

#### metadata

    BinaryType metadata​(int typeId,
                        int schemaId)
                 throws BinaryObjectException

Gets metadata for provided type ID and schema ID.

Parameters:
  `typeId` - Type ID.
  `schemaId` - Schema ID.
Returns:
  Metadata.
Throws:
  `BinaryObjectException` - In case of error.

#### metadata

    Collection<BinaryType> metadata()
                             throws BinaryObjectException

Gets all metadata known to the node.

Returns:
  Metadata collection
Throws:
  `BinaryObjectException` - If failed.